Index: /branches/water/src/story_entities/game_world.cc
===================================================================
--- /branches/water/src/story_entities/game_world.cc	(revision 7689)
+++ /branches/water/src/story_entities/game_world.cc	(revision 7690)
@@ -33,5 +33,5 @@
 #include "terrain.h"
 #include "playable.h"
-#include "mapped_water.h"
+#include "environments/mapped_water.h"
 
 #include "light.h"
@@ -445,6 +445,4 @@
   // clear buffer
   glClear( GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
-  // draw world
-  //   this->draw();
 
   // render the reflection texture
@@ -479,5 +477,5 @@
   MappedWater* mw;
 
-  if( reflectedWaters = ClassList::getList(CL_MAPPED_WATER) != NULL)
+  if( (reflectedWaters = ClassList::getList(CL_MAPPED_WATER)) != NULL)
   {
     std::list<BaseObject*>::const_iterator it;
@@ -536,12 +534,4 @@
 
 /**
- * @brief runs through all entities calling their draw() methods
- */
-void GameWorld::draw ()
-{
-
-}
-
-/**
  *  shows the loading screen
  */
Index: /branches/water/src/story_entities/game_world.h
===================================================================
--- /branches/water/src/story_entities/game_world.h	(revision 7689)
+++ /branches/water/src/story_entities/game_world.h	(revision 7690)
@@ -74,5 +74,5 @@
     virtual void renderPassRefraction();
     virtual void renderPassAll();
-    virtual void draw();
+
 
     virtual void display();
Index: /branches/water/src/world_entities/WorldEntities.am
===================================================================
--- /branches/water/src/world_entities/WorldEntities.am	(revision 7689)
+++ /branches/water/src/world_entities/WorldEntities.am	(revision 7690)
@@ -1,101 +1,101 @@
 ## THE SUBCLASSES. THESE MUST BE DYNAMICALLY LINKED OR COMPILED IN DIRECTLY
 WorldEntities_SOURCES_ = \
-		world_entities/npcs/npc_test1.cc \
-		world_entities/npcs/npc_test.cc \
-		world_entities/npcs/ground_turret.cc \
-		\
-		world_entities/environment.cc \
-		world_entities/skysphere.cc \
-		world_entities/skybox.cc \
-		world_entities/terrain.cc \
-		world_entities/satellite.cc \
-		world_entities/movie_entity.cc \
-		world_entities/recorder.cc \
-		world_entities/character_attributes.cc \
-		world_entities/test_entity.cc \
-		world_entities/planet.cc \
-		\
-		world_entities/weapons/test_gun.cc \
-		world_entities/weapons/turret.cc \
-		world_entities/weapons/aiming_turret.cc \
-		world_entities/weapons/targeting_turret.cc \
-		world_entities/weapons/cannon.cc \
-		world_entities/weapons/hyperblaster.cc \
-		world_entities/weapons/aim.cc \
-		\
-		world_entities/projectiles/bomb.cc \
-		world_entities/projectiles/laser.cc \
-		world_entities/projectiles/test_bullet.cc \
-		world_entities/projectiles/rocket.cc \
-		world_entities/projectiles/guided_missile.cc \
-		world_entities/projectiles/hyperblast.cc \
-		\
-		world_entities/power_ups/turret_power_up.cc \
-		world_entities/power_ups/laser_power_up.cc \
-		\
-		world_entities/space_ships/space_ship.cc \
-		world_entities/space_ships/helicopter.cc \
-		world_entities/space_ships/hover.cc \
-		world_entities/space_ships/turbine_hover.cc \
-		world_entities/creatures/md2_creature.cc \
-		\
-		\
-		world_entities/environments/water.cc \
-		world_entities/environments/model_entity.cc \
-		world_entities/environments/building.cc \
-    world_entities/environments/mapped_water.cc \  
-		\
-		world_entities/elements/image_entity.cc \
-		world_entities/elements/text_element.cc \
-		\
-		world_entities/effects/lightning_bolt.cc
+                world_entities/npcs/npc_test1.cc \
+                world_entities/npcs/npc_test.cc \
+                world_entities/npcs/ground_turret.cc \
+                \
+                world_entities/environment.cc \
+                world_entities/skysphere.cc \
+                world_entities/skybox.cc \
+                world_entities/terrain.cc \
+                world_entities/satellite.cc \
+                world_entities/movie_entity.cc \
+                world_entities/recorder.cc \
+                world_entities/character_attributes.cc \
+                world_entities/test_entity.cc \
+                world_entities/planet.cc \
+                \
+                world_entities/weapons/test_gun.cc \
+                world_entities/weapons/turret.cc \
+                world_entities/weapons/aiming_turret.cc \
+                world_entities/weapons/targeting_turret.cc \
+                world_entities/weapons/cannon.cc \
+                world_entities/weapons/hyperblaster.cc \
+                world_entities/weapons/aim.cc \
+                \
+                world_entities/projectiles/bomb.cc \
+                world_entities/projectiles/laser.cc \
+                world_entities/projectiles/test_bullet.cc \
+                world_entities/projectiles/rocket.cc \
+                world_entities/projectiles/guided_missile.cc \
+                world_entities/projectiles/hyperblast.cc \
+                \
+                world_entities/power_ups/turret_power_up.cc \
+                world_entities/power_ups/laser_power_up.cc \
+                \
+                world_entities/space_ships/space_ship.cc \
+                world_entities/space_ships/helicopter.cc \
+                world_entities/space_ships/hover.cc \
+                world_entities/space_ships/turbine_hover.cc \
+                world_entities/creatures/md2_creature.cc \
+                \
+                \
+                world_entities/environments/water.cc \
+                world_entities/environments/model_entity.cc \
+                world_entities/environments/building.cc \
+                world_entities/environments/mapped_water.cc \
+                \
+                world_entities/elements/image_entity.cc \
+                world_entities/elements/text_element.cc \
+                \
+                world_entities/effects/lightning_bolt.cc
 
 
 WorldEntities_HEADERS_ = \
-		npcs/npc_test.h \
-		npcs/npc_test1.h \
-		npcs/ground_turret.h \
-		environment.h \
-		skysphere.h \
-		skybox.h \
-		terrain.h \
-		satellite.h \
-		movie_entity.h \
-		recorder.h \
-		character_attributes.h \
-		test_entity.h \
-		planet.h \
-		\
-		weapons/test_gun.h \
-		weapons/cannon.h \
-		weapons/hyperblaster.h \
-		weapons/turret.h \
-		weapons/aiming_turret.h \
-		weapons/targeting_turret.h \
-		weapons/aim.h \
-		\
-		projectiles/bomb.h \
-		projectiles/laser.h \
-		projectiles/test_bullet.h \
-		projectiles/rocket.h \
-		projectiles/guided_missile.h \
-		projectiles/hyperblast.h \
-		\
-		power_ups/turret_power_up.h \
-		power_ups/laser_power_up.h \
-		\
-		space_ships/space_ship.h \
-		space_ships/helicopter.h \
-		space_ships/hover.h \
-		space_ships/turbine_hover.h \
-		creatures/md2_creature.h \
-		\
-		environments/water.h \
-		environments/model_entity.h \
-		environments/building.h \
-    environments/mapped_water.h \  
-		\
-		elements/image_entity.h \
-		elements/text_element.h \
-		\
-		effects/lightning_bolt.h
+                npcs/npc_test.h \
+                npcs/npc_test1.h \
+                npcs/ground_turret.h \
+                environment.h \
+                skysphere.h \
+                skybox.h \
+                terrain.h \
+                satellite.h \
+                movie_entity.h \
+                recorder.h \
+                character_attributes.h \
+                test_entity.h \
+                planet.h \
+                \
+                weapons/test_gun.h \
+                weapons/cannon.h \
+                weapons/hyperblaster.h \
+                weapons/turret.h \
+                weapons/aiming_turret.h \
+                weapons/targeting_turret.h \
+                weapons/aim.h \
+                \
+                projectiles/bomb.h \
+                projectiles/laser.h \
+                projectiles/test_bullet.h \
+                projectiles/rocket.h \
+                projectiles/guided_missile.h \
+                projectiles/hyperblast.h \
+                \
+                power_ups/turret_power_up.h \
+                power_ups/laser_power_up.h \
+                \
+                space_ships/space_ship.h \
+                space_ships/helicopter.h \
+                space_ships/hover.h \
+                space_ships/turbine_hover.h \
+                creatures/md2_creature.h \
+                \
+                environments/water.h \
+                environments/model_entity.h \
+                environments/building.h \
+                environments/mapped_water.h \
+                \
+                elements/image_entity.h \
+                elements/text_element.h \
+                \
+                effects/lightning_bolt.h