Index: code/branches/lastmanstanding2/data/overlays/lastTeamStandingHUD.oxo
===================================================================
--- code/branches/lastmanstanding2/data/overlays/lastTeamStandingHUD.oxo	(revision 7697)
+++ code/branches/lastmanstanding2/data/overlays/lastTeamStandingHUD.oxo	(revision 7699)
@@ -1,4 +1,4 @@
 <Template name="LastteamstandingHUD">
-  <OverlayGroup name="DynamicmatcHUD" scale = "1, 1">
+  <OverlayGroup name="LastteamstandingHUD" scale = "1, 1">
 
 <GametypeFadingMessage
@@ -30,5 +30,5 @@
 
      showlives     = true
-     showplayers     = false
+     showteams     = false
     />
 
@@ -40,5 +40,5 @@
      colour    = "1.0, 1.0, 1.0, 1.0"
      align     = "left"
-     caption   = "Players: "
+     caption   = "Teams: "
     />
 
@@ -52,5 +52,5 @@
 
      showlives     = false
-     showplayers     = true
+     showteams     = true
     />
 
Index: code/branches/lastmanstanding2/src/orxonox/gametypes/LastTeamStanding.cc
===================================================================
--- code/branches/lastmanstanding2/src/orxonox/gametypes/LastTeamStanding.cc	(revision 7697)
+++ code/branches/lastmanstanding2/src/orxonox/gametypes/LastTeamStanding.cc	(revision 7699)
@@ -52,9 +52,10 @@
         this->bHardPunishment=false;
         this->punishDamageRate=0.4f;
-        this->setHUDTemplate("LastTeamStandingHUD");
+        this->setHUDTemplate("LastTeamStandingHUD");//tolowercase:-)
         this->eachTeamsPlayers = new int[teams_];
+        this->bMinPlayersReached = false;
     }
     
-    void LastTeamStanding::~LastTeamStanding()
+    LastTeamStanding::~LastTeamStanding()
     {
         delete[] this->eachTeamsPlayers;
@@ -138,5 +139,5 @@
     }
 
-    void LastTeamStanding::end()
+    void LastTeamStanding::end()//TODO!
     {
         Gametype::end();
@@ -171,5 +172,5 @@
         if (!player)// only for safety
             return;
-        Deathmatch::playerEntered(player);
+        TeamDeathmatch::playerEntered(player);
         if (teamsAlive<=1)
             playerLives_[player]=lives;
@@ -180,5 +181,6 @@
             this->teamsAlive++;
         this->eachTeamsPlayers[getTeam(player)]++;
-        
+        if (teamsAlive>1) // Now the game is allowed to end, since there are at least two teams.
+            bMinPlayersReached=true;
         this->timeToAct_[player]=timeRemaining;
         this->playerDelayTime_[player]=respawnDelay;
@@ -188,5 +190,5 @@
     bool LastTeamStanding::playerLeft(PlayerInfo* player)
     {
-        bool valid_player = Deathmatch::playerLeft(player);
+        bool valid_player = TeamDeathmatch::playerLeft(player);
         if (valid_player)
         {
@@ -255,5 +257,5 @@
         if(this->hasStarted()&&(!this->hasEnded()))
         {
-            if ((this->hasStarted()&&(teamsAlive<=1)))//last team remaining
+            if (bMinPlayersReached &&(this->hasStarted()&&(teamsAlive<=1)))//last team remaining
             {
                 this->end();
Index: code/branches/lastmanstanding2/src/orxonox/gametypes/LastTeamStanding.h
===================================================================
--- code/branches/lastmanstanding2/src/orxonox/gametypes/LastTeamStanding.h	(revision 7697)
+++ code/branches/lastmanstanding2/src/orxonox/gametypes/LastTeamStanding.h	(revision 7699)
@@ -35,7 +35,9 @@
 
 #include "OrxonoxPrereqs.h"
-#include "Deathmatch.h"
+#include "TeamDeathmatch.h"
 #include <map>
 #include <vector>
+
+//TODO: Hud doesn load; problem with destructor; teams are not assigned properly; 
 
 namespace orxonox
@@ -63,5 +65,6 @@
             virtual void spawnDeadPlayersIfRequested(); //!< Prevents dead players to respawn.
             virtual int getMinLives(); //!< Returns minimum of each player's lives; players with 0 lives are skipped;
-            unsigned int * eachTeamsPlayers; //!<Each teams player's alive.
+            int * eachTeamsPlayers; //!<Each teams player's alive.
+            bool bMinPlayersReached;
 
         public: