Index: /branches/cd/src/lib/collision_detection/obb_tree_node.cc
===================================================================
--- /branches/cd/src/lib/collision_detection/obb_tree_node.cc	(revision 7707)
+++ /branches/cd/src/lib/collision_detection/obb_tree_node.cc	(revision 7708)
@@ -334,5 +334,4 @@
     maxLength[k] = p->distancePoint(tmpVec);
     minLength[k] = p->distancePoint(tmpVec);
-//     PRINT(0)("axis[%i]: %f %f %f\n", k, box.axis[k].x, box.axis[k].y, box.axis[k].z);
 
     for( int j = 0; j < length; ++j) {
@@ -490,7 +489,7 @@
     return;
 
-  PRINTF(3)("collideWith\n");
+  PRINTF(4)("collideWith\n");
   /* if the obb overlap, make subtests: check which node is realy overlaping  */
-  PRINTF(3)("Checking OBB %i vs %i: ", this->getIndex(), treeNode->getIndex());
+  PRINTF(4)("Checking OBB %i vs %i: ", this->getIndex(), treeNode->getIndex());
   //   if( unlikely(treeNode == NULL)) return;
 
@@ -498,10 +497,10 @@
   if( this->overlapTest(*this->bvElement, *(((const OBBTreeNode*)&treeNode)->bvElement), nodeA, nodeB))
   {
-    PRINTF(3)("collision @ lvl %i, object %s vs. %s, (%p, %p)\n", this->depth, nodeA->getClassName(), nodeB->getClassName(), this->nodeLeft, this->nodeRight);
+    PRINTF(4)("collision @ lvl %i, object %s vs. %s, (%p, %p)\n", this->depth, nodeA->getClassName(), nodeB->getClassName(), this->nodeLeft, this->nodeRight);
 
     /* check if left node overlaps */
     if( likely( this->nodeLeft != NULL))
     {
-      PRINTF(3)("Checking OBB %i vs %i: ", this->nodeLeft->getIndex(), treeNode->getIndex());
+      PRINTF(4)("Checking OBB %i vs %i: ", this->nodeLeft->getIndex(), treeNode->getIndex());
       if( this->overlapTest(*this->nodeLeft->bvElement, *(((const OBBTreeNode*)&treeNode)->bvElement), nodeA, nodeB))
       {
@@ -513,5 +512,5 @@
     if( likely( this->nodeRight != NULL))
     {
-      PRINTF(3)("Checking OBB %i vs %i: ", this->nodeRight->getIndex(), treeNode->getIndex());
+      PRINTF(4)("Checking OBB %i vs %i: ", this->nodeRight->getIndex(), treeNode->getIndex());
       if(this->overlapTest(*this->nodeRight->bvElement, *(((const OBBTreeNode*)&treeNode)->bvElement), nodeA, nodeB))
       {
@@ -586,9 +585,9 @@
     rB += fabs(boxB.halfLength[2] * rotAxisB[2].dot(l));
 
-    PRINTF(3)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
+    PRINTF(5)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
 
     if( (rA + rB) < fabs(t.dot(l)))
     {
-      PRINTF(3)("no Collision\n");
+      PRINTF(4)("no Collision\n");
       return false;
     }
@@ -610,9 +609,9 @@
     rB += fabs(boxB.halfLength[2] * rotAxisB[2].dot(l));
 
-    PRINTF(3)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
+    PRINTF(5)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
 
     if( (rA + rB) < fabs(t.dot(l)))
     {
-      PRINTF(3)("no Collision\n");
+      PRINTF(4)("no Collision\n");
       return false;
     }
@@ -638,9 +637,9 @@
       rB += fabs(boxB.halfLength[2] * rotAxisB[2].dot(l));
 
-      PRINTF(3)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
+      PRINTF(5)("s = %f, rA+rB = %f\n", fabs(t.dot(l)), rA+rB);
 
       if( (rA + rB) < fabs(t.dot(l)))
       {
-        PRINTF(3)("keine Kollision\n");
+        PRINTF(4)("keine Kollision\n");
         return false;
       }
@@ -653,5 +652,5 @@
 
 
-  PRINTF(3)("Kollision!\n");
+  PRINTF(4)("Kollision!\n");
   return true;
 }
@@ -681,19 +680,8 @@
         glBegin(GL_POINTS);
         glColor3f(0.3, 0.8, 0.54);
-        for( int i = 0; i < this->bvElement->modelInf->numTriangles; ++i)
-        {
-          for(int j = 0; j < 3; ++j)
-          {
-            glVertex3f(
-                (&this->bvElement->modelInf->pVertices[this->bvElement->modelInf->pTriangles[i].indexToVertices[j]])[0],
-                (&this->bvElement->modelInf->pVertices[this->bvElement->modelInf->pTriangles[i].indexToVertices[j]])[1],
-                (&this->bvElement->modelInf->pVertices[this->bvElement->modelInf->pTriangles[i].indexToVertices[j]])[2]);
-          }
-        }
-
-//         for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
-//           glVertex3f(this->bvElement->modelInf->pVertices[i],
-//                      this->bvElement->modelInf->pVertices[i+1],
-//                      this->bvElement->modelInf->pVertices[i+2]);
+        for( int i = 0; i < this->bvElement->modelInf->numVertices*3; i+=3)
+          glVertex3f(this->bvElement->modelInf->pVertices[i],
+                     this->bvElement->modelInf->pVertices[i+1],
+                     this->bvElement->modelInf->pVertices[i+2]);
         glEnd();
       }